
static double cpneum[4], cpneuzr[4][4], cpneuzi[4][4];
static double cphm[3], cphz[3][3], cphl[3][4];
static double cpcm[2], cpcmr[2][2], cpcmi[2][2],cpcpr[2][2],cpcpi[2][2];
static double cplm[2], cplzr[2][2], cplzi[2][2];
static double cpbm[2], cpbzr[2][2], cpbzi[2][2];
static double cptm[2], cptzr[2][2], cptzi[2][2];

static double sEE,sMZ,sSW,sMl,sMb,sMt,swZ,swW,stb, sMHc, smu, smui, sMG1,
sMG1i, sMG2;

double cpvset1(double EE, double MZ, double SW, double Ml, double Mb,
	double Mt, double wZ, double wW, double tb, double MHc, double mu, 
	double mui, double MG1, double MG1i, double MG2)
	{
	sEE=EE;
	sMZ=MZ;
	sSW=SW;
	sMl=Ml;
	sMb=Mb;
	sMt=Mt;
	swZ=wZ;
	swW=wW;
	stb=tb;
	sMHc=MHc;
	smu=mu;
	smui=mui;
	sMG1=MG1;
	sMG1i=MG1i;
	sMG2=MG2;
	return 0.0;	
 	}

double cpvset2(double MG2i, double MG3, double MG3i, double Mq3, 
	double Mu3, double Md3, double Ml3, double Mr3, double At, double Ati,
	double Ab, double Abi, double Al, double Ali, double cptkn1)
{
	FILE *f;
	int i,j,k,nr=0;
	double val;
	f=fopen("cpsuperh.in","w");
	if(f==0)
	{
		puts("!!!!!!!!!! can not open cpsuperh.in for writing !!!!!!!!!");
		return 0.0;
	}
	
	fprintf(f,"%f\n0.1172\n%f\n%f\n",1.0/(sEE*sEE/4.0/M_PI),sMZ,sSW*sSW);
	fprintf(f,"0.5D-3\n0.1065D0\n%f\n6.D-3\n0.115D0\n3.0D0\n",sMl);
	fprintf(f,"3.D-3\n0.62D0\n%f\n%f\n%f\n",sMt,swW,swZ);
	fprintf(f,"%15.8E\n%15.8E\n%15.8E\n%15.8E\n",stb,sMHc,
		sqrt(smu*smu+smui*smui),atan2(smui,smu)*180.0/M_PI);
	fprintf(f,"%15.8E\n%15.8E\n%15.8E\n%15.8E\n",sqrt(sMG1*sMG1+sMG1i*sMG1i),
			atan2(sMG1i,sMG1)*180.0/M_PI, sqrt(sMG2*sMG2+MG2i*MG2i),
			atan2(MG2i,sMG2)*180.0/M_PI);
	fprintf(f,"%15.8E\n%15.8E\n%15.8E\n%15.8E\n",sqrt(MG3*MG3+MG3i*MG3i),
			atan2(MG3i,MG3)*180.0/M_PI,Mq3,Mu3);
	fprintf(f,"%15.8E\n%15.8E\n%15.8E\n",Md3,Ml3,Mr3);
	fprintf(f,"%15.8E\n%15.8E\n%15.8E\n%15.8E\n",sqrt(At*At+Ati*Ati),
			atan2(Ati,At)*180.0/M_PI,sqrt(Ab*Ab+Abi*Abi),
			atan2(Abi,Ab)*180.0/M_PI);
	fprintf(f,"%15.8E\n%15.8E\n0\n0\n0\n0\n0\n0\n0\n0\n",sqrt(Al*Al+Ali*Ali),
			atan2(Ali,Al)*180.0/M_PI);
	fclose(f);
	if(access("cpsuperh.out",F_OK)==0) unlink("cpsuperh.out");
	system("./cpsuperh.exe < cpsuperh.in > cpsuperh.out");
	if(access("cpsuperh.out",R_OK)!=0)
	{
		puts("Can not run ./cpsuperh.exe !!!!!");
		return 0;
	}
	
	f=fopen("cpsuperh.out","r");
	if(f==0)
	{
		puts("!!!!!!!!!! can not open cpsuperh.in for writing !!!!!!!!!");
		return 0.0;
	}
	
	while(fscanf(f,"%d%d%d%lf",&k,&i,&j,&val)==4)
	{
		switch(k)
		{
			case 1:
				if(i==0)
					cpneum[j-1]=val;
				else
					cpneuzr[j-1][i-1]=val;
				break;
			case 2:
				cpneuzi[j-1][i-1]=-val;
				break;
			case 3:
				if(i==0)
					cpcm[j-1]=val;
				else
					cpcmr[j-1][i-1]=val;
				break;
			case 4:
				cpcmi[j-1][i-1]=val;
				break;
			case 5:
				cpcpr[j-1][i-1]=val;
				break;
			case 6:
				cpcpi[j-1][i-1]=val;
				break;
			case 11:
				if(i==0)
					cphm[j-1]=val;
				else
					cphz[i-1][j-1]=val;
				break;
			case 12:
				cphl[i-1][j-1]=-val;
				break;
				
			case 21:
				if(i==0)
					cplm[j-1]=val;
				else
					cplzr[j-1][i-1]=val;
				break;
			case 22:
				cplzi[j-1][i-1]=val;
				break;
			case 23:
				if(i==0)
					cpbm[j-1]=val;
				else
					cpbzr[j-1][i-1]=val;
				break;
			case 24:
				cpbzi[j-1][i-1]=val;
				break;
			case 25:
				if(i==0)
					cptm[j-1]=val;
				else
					cptzr[j-1][i-1]=val;
				break;
			case 26:
				cptzi[j-1][i-1]=val;
				break;
		}
	}
	
	return 0.0;
}

double cpvcalc(double tk, double tp, double i1, double i2)
{
	int t=(int)tp, i=(int)i1, j=(int)i2;
	switch(t)
	{
		case 1:
			if(i==0)
				return cpneum[j-1];
			else
				return cpneuzr[i-1][j-1];
		case 2:
			return cpneuzi[i-1][j-1];
		case 3:
			if(i==0)
				return cpcm[j-1];
			else
				return cpcmr[i-1][j-1];
		case 4:
			return cpcmi[i-1][j-1];
		case 5:
			return cpcpr[i-1][j-1];
		case 6:
			return cpcpi[i-1][j-1];
		case 11:
			if(i==0)
				return cphm[j-1];
			else
				return cphz[i-1][j-1];
		case 12:
				if(j>4) j-=4;
				return cphl[i-1][j-1];
		case 21:
			if(i==0)
				return cplm[j-1];
			else
				return cplzr[i/3-1][j/3-1];
		case 22:
				return cplzi[i/3-1][j/3-1];
		case 23:
			if(i==0)
				return cpbm[j-1];
			else
				return cpbzr[i/3-1][j/3-1];
		case 24:
				return cpbzi[i/3-1][j/3-1];
		case 25:
			if(i==0)
				return cptm[j-1];
			else
				return cptzr[i/3-1][j/3-1];
		case 26:
				return cptzi[i/3-1][j/3-1];
	}
	
	return 0.0;
}
