#include <math.h>
#include <stdio.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>
	
/*		
static double mysqrt(double x)
{
	if(x<0)
		return -sqrt(-x);
	else
		return sqrt(x);
}
*/

static double neuz[32][32], neur[32];


double neudiag5(double di, double dj, double tk)
{
	int i,j;
	
	if(tk<0.5)
		return 0.0;
	i=floor(di+0.5);
	j=floor(dj+0.5);
	if(i==0)
		return neur[j-1];
	else
		return neuz[j-1][i-1];
}

static double nmmtop,nmm1,nmm2,nmm3,nml3,nmr3,nmq3,nmu3,nmd3,nmatau,nmatop,nmab;
static double hisz[32][32], hisr[32];
static double hipz[32][32], hipr[32];

double higs0(double mtop, double m1, double m2, double m3, double l3,
		double r3, double q3, double u3, double d3, double atau, double at, double ab)
{
	nmmtop=mtop;
	nmm1=m1;
	nmm2=m2;
	nmm3=m3;
	nml3=l3;
	nmr3=r3;
	nmq3=q3;
	nmu3=u3;
	nmd3=d3;
	nmatau=atau;
	nmatop=at;
	nmab=ab;
	return 1.0;
}

double higs1(double sw, double mw, double ee, double tb, 
	double hk, double hl, double xvev, double hks, double hls, double token)
{
	double neum[32][32], nmhpz[2][2];
	int n=3, blt=0;
	int i, j, ff=1;
	double cb=1.0/sqrt(1.0+tb*tb);
	double sb=tb*cb;
	double cw=sqrt(1.0-sw*sw);
	double vev=sqrt(2.0)*mw*sw/ee;
	double dlh1=0.0,dlh2=0.0,dlh3=0.0,dlh1s=0.0,dlh2s=0.0,dlhss=0.0;
	double dlh5s=0.0, dlh8s=0.0, dlh5=0.0, dlh4=0.0;
	char cbuf[1000];
	FILE *f;
	
	
	cb=1.0/sqrt(1.0+tb*tb);
	sb=tb*cb;
	
	
	f=fopen("slhainp.dat","w");
	if(f==0)
	{
		puts("Can not create file slhainp.dat !!!!!!!");
		return 0.0;
	}
	
	fprintf(f,"BLOCK MODSEL\n  3     1     # NMSSM PARTICLE CONTENT\n");
	fprintf(f,"BLOCK SMINPUTS\n");
	fprintf(f,"  1   %.15E  # alpha_em^-1\n",4.0*M_PI/ee/ee);
	fprintf(f,"  2   %.15E  # Gf\n",ee*ee/4.0/sqrt(2.0)/mw/mw/sw/sw);
	fprintf(f,"  3   %.15E  # alpha_s_MZ\n",0.12);
	fprintf(f,"  4   %.15E  # MZ\n",mw/cw);
	fprintf(f,"  5   %.15E  # Mb\n",4.24);
	fprintf(f,"  6   %.15E  # top quark pole mass\n",nmmtop);
	fprintf(f,"  7   %.15E  # Mtau\n",1.7771);
	fprintf(f,"BLOCK MINPAR\n  3    %.15E     # TANBETA\n",tb);
	fprintf(f,"BLOCK EXTPAR\n");
	fprintf(f,"  1   %.15E   # M1\n",nmm1);
	fprintf(f,"  2   %.15E   # M2\n",nmm2);
	fprintf(f,"  3   %.15E   # M3\n",nmm3);
	fprintf(f,"  11  %.15E   # Atop\n",nmatau);
	fprintf(f,"  12  %.15E   # Atau\n",nmatop);
	fprintf(f,"  13  %.15E   # Abot\n",nmab);
	fprintf(f,"  23  %.15E   # mu\n",-hl*xvev);
	fprintf(f,"  31  %.15E   # left se\n",nml3);
	fprintf(f,"  32  %.15E   # left smu\n",nml3);
	fprintf(f,"  33  %.15E   # left stau\n",nml3);
	fprintf(f,"  34  %.15E   # right se\n",nmr3);
	fprintf(f,"  35  %.15E   # right smu\n",nmr3);
	fprintf(f,"  36  %.15E   # right stau\n",nmr3);
	fprintf(f,"  41  %.15E   # left sq1\n",nmq3);
	fprintf(f,"  42  %.15E   # left sq2\n",nmq3);
	fprintf(f,"  43  %.15E   # left sq3\n",nmq3);
	fprintf(f,"  44  %.15E   # right su\n",nmu3);
	fprintf(f,"  45  %.15E   # right sc\n",nmu3);
	fprintf(f,"  46  %.15E   # right st\n",nmu3);
	fprintf(f,"  47  %.15E   # right sd\n",nmd3);
	fprintf(f,"  48  %.15E   # right ss\n",nmd3);
	fprintf(f,"  49  %.15E   # right sb\n",nmd3);
	fprintf(f,"  61  %.15E   # lambda\n",-hl);
	fprintf(f,"  62  %.15E   # kappa \n",-hk);
	fprintf(f,"  63  %.15E   # a_lambda\n",-hls);
	fprintf(f,"  64  %.15E   # a_kappa\n",hks);
	fclose(f);
	if(access("spectr.dat",F_OK)==0) unlink("spectr.dat");
	system("./nmhdecay");
	if(access("spectr.dat",R_OK)!=0)
	{
		puts("Can not run ./nmhdecay !!!!!");
		return 0;
	}
	
	f=fopen("spectr.dat","r");
	while(fgets(cbuf,1000,f))
	{
		int i1,i2;
		double v;
		for(i=0;cbuf[i];i++)
			if(isalpha(cbuf[i]) && isupper(cbuf[i])) cbuf[i]=tolower(cbuf[i]);
		if(strncmp(cbuf,"block",5)==0)
		{
			char blnm[20];
			sscanf(cbuf+5,"%s",blnm);
			if(strcmp(blnm,"higmix")==0) blt=11;
			else if(strcmp(blnm,"amix")==0) blt=12;
			else if(strcmp(blnm,"nmix")==0) blt=13;
			else if(strcmp(blnm,"mass")==0) blt=3;
			else blt=0;
			continue;
		}
		if(cbuf[0]!=' ')
			continue;
		if(blt==0)
			continue;
		
		if(blt<10 && sscanf(cbuf,"%d%lf",&i1,&v)!=2)
			continue;
		if(blt>10 && sscanf(cbuf,"%d%d%lf",&i1,&i2,&v)!=3)
			continue;
		
		switch(blt)
		{
			case 3:
				if(i1==25) hisr[0]=v*v;
				if(i1==35) hisr[1]=v*v;
				if(i1==45) hisr[2]=v*v;
				if(i1==36) hipr[0]=v*v;
				if(i1==37) hipr[3]=v*v;
				if(i1==46) hipr[1]=v*v;
				if(i1==1000022) neur[0]=v;
				if(i1==1000023) neur[1]=v;
				if(i1==1000025) neur[2]=v;
				if(i1==1000035) neur[3]=v;
				if(i1==1000045) neur[4]=v;
				break;
			case 11:
				if(i1==1 && i2==1) hisz[1][0]=v;
				if(i1==1 && i2==2) hisz[1][1]=v;
				if(i1==1 && i2==3) hisz[1][2]=v;
				if(i1==2 && i2==1) hisz[0][0]=v;
				if(i1==2 && i2==2) hisz[0][1]=v;
				if(i1==2 && i2==3) hisz[0][2]=v;
				if(i1==3 && i2==1) hisz[2][0]=v;
				if(i1==3 && i2==2) hisz[2][1]=v;
				if(i1==3 && i2==3) hisz[2][2]=v;
				break;
			case 12:
				if(i1<3 && i2<3) nmhpz[i1-1][i2-1]=v;
				break;
			case 13:
				if(i1<6 && i2<6) neuz[i1-1][i2-1]=v;
				break;
			default:
				break;
		}
	}
	
	fclose(f);	
	
	/****************    ODD ************************/

	
	neum[0][0]= hl*xvev*tb*(hls+hk*xvev)-2.0*vev*vev*dlh5*sb*sb+0.5/cb*dlh5s*sb*xvev*xvev;
	neum[1][1]= hl*xvev/tb*(hls+hk*xvev)-2.0*vev*vev*dlh5*cb*cb+0.5*cb*dlh5s/sb*xvev*xvev;
	neum[2][2]=4*vev*vev*hk*hl*cb*sb+3*hk*hks*xvev+vev*vev*hl*hls/xvev*cb*sb
				+2*vev*vev*cb*dlh5s*sb-16*dlh8s*xvev*xvev;
	
	neum[0][1]=neum[1][0]= hl*xvev*(hls+hk*xvev)-2*vev*vev*cb*dlh5*sb+0.5*dlh5s*xvev*xvev;
	
	neum[0][2]=neum[2][0]= hl*vev*sb*(hls-2*hk*xvev)+vev*dlh5s*sb*xvev;
	
	neum[1][2]=neum[2][1]= hl*vev*cb*(hls-2*hk*xvev)+vev*cb*dlh5s*xvev;

		
	hipz[0][0]=-nmhpz[0][0]*sb; hipz[0][1]=-nmhpz[0][0]*cb; hipz[0][2]=-nmhpz[0][1];
	hipz[1][0]=nmhpz[1][0]*sb; hipz[1][1]=nmhpz[1][0]*cb; hipz[1][2]=nmhpz[1][1];
	hipz[2][0]=            cb; hipz[2][1]=           -sb; hipz[2][2]=0.0;
	hipr[2]=0.0;
	
	{
		double orimm[3][3];
		int i1,i2;
		for(i1=0;i1<3;i1++) for(i2=0;i2<3;i2++)
		orimm[i1][i2]=
			hipz[0][i1]*hipz[0][i2]*hipr[0]+
			hipz[1][i1]*hipz[1][i2]*hipr[1]+
			hipz[2][i1]*hipz[2][i2]*hipr[2];

		dlh5s=hisr[21]=(orimm[0][2]-neum[0][2])/vev/xvev/sb;
		dlh5 =hisr[20]=(orimm[0][0]-neum[0][0]-0.5/cb*dlh5s*sb*xvev*xvev)/(-2.0)/vev/vev/sb/sb;
		dlh8s=hisr[22]=(orimm[2][2]-neum[2][2]-2*vev*vev*cb*dlh5s*sb)/(-16.0)/xvev/xvev;
		dlh4 =hisr[23]=-(hipr[3]-mw*mw-xvev*hl*(hls+hk*xvev)/cb/sb+vev*vev*(hl*hl+dlh5)
				-0.5/cb/sb*xvev*xvev*dlh5s)/vev/vev;

		
	}
	
	
	/***********************   EVEN  ******************************/
	
	
	neum[0][0]= 1.0/cw/cw*mw*mw*cb*cb+hl*hls*tb*xvev+(hk*hl+0.5*dlh5s)*tb*xvev*xvev
					+2.0*vev*vev*cb*cb*dlh1;
	neum[1][1]= 1.0/cw/cw*mw*mw*sb*sb+hl*hls/tb*xvev+(hk*hl+0.5*dlh5s)/tb*xvev*xvev
					+2.0*vev*vev*sb*sb*dlh2;
	neum[2][2]=4*hk*hk*xvev*xvev+vev*vev*hl*hls/xvev*cb*sb-hk*hks*xvev
			+(2.0*dlhss+8.0*dlh8s)*xvev*xvev;
	
	neum[0][1]=neum[1][0]= -1.0/cw/cw*mw*mw*cb*sb+2.0*vev*vev*cb*sb*hl*hl
			-xvev*hl*(hls+xvev*hk)
			+2*vev*vev*cb*(dlh3+dlh4+dlh5)*sb-0.5*xvev*xvev*dlh5s;
	neum[0][2]=neum[2][0]=vev*(2.0*hl*hl*xvev*cb-2*hk*hl*xvev*sb-hl*hls*sb-dlh5s*sb*xvev)
			+2*vev*cb*dlh1s*xvev;
	
	neum[1][2]=neum[2][1]=vev*(2.0*hl*hl*xvev*sb-2*hk*hl*xvev*cb-hl*hls*cb-dlh5s*cb*xvev)
			+2*vev*sb*dlh2s*xvev;


		
		
	{
		double orimm[3][3];
		int i1,i2;
		for(i1=0;i1<3;i1++) for(i2=0;i2<3;i2++)
		orimm[i1][i2]=
			hisz[0][i1]*hisz[0][i2]*hisr[0]+
			hisz[1][i1]*hisz[1][i2]*hisr[1]+
			hisz[2][i1]*hisz[2][i2]*hisr[2];

		
		dlh1=hisr[10]=(orimm[0][0]-neum[0][0])/2.0/vev/vev/cb/cb;
		dlh2=hisr[11]=(orimm[1][1]-neum[1][1])/2.0/vev/vev/sb/sb;
		dlh3=hisr[12]=(orimm[0][1]-neum[0][1])/2.0/vev/vev/sb/cb;
		dlh1s=hisr[13]=(orimm[0][2]-neum[0][2])/2.0/vev/xvev/cb;
		dlh2s=hisr[14]=(orimm[1][2]-neum[1][2])/2.0/vev/xvev/sb;
		dlhss=hisr[15]=(orimm[2][2]-neum[2][2])/2.0/xvev/xvev;
		
	}
	
		
	return 1.0;
}

double higs2(double di, double dj, double tk)
{
	int i,j;
	
	if(tk<0.5)
		return 0.0;
	i=floor(di+0.5);
	j=floor(dj+0.5);
	if(i==0)
		return j<9?mysqrt(hisr[j-1]):hisr[j-1];
	else
		return hisz[j-1][i-1];
}


double higp2(double di, double dj, double tk)
{
	int i,j;
	
	if(tk<0.5)
		return 0.0;
	i=floor(di+0.5);
	j=floor(dj+0.5);
	if(i==0)
		return mysqrt(hipr[j-1]);
	else
		return hipz[j-1][i-1];
}


